# coding=utf-8
# --------------------------------------------------------------------------
# Copyright (c) Microsoft Corporation. All rights reserved.
# Licensed under the MIT License. See License.txt in the project root for
# license information.
#
# Code generated by Microsoft (R) AutoRest Code Generator 2.3.33.0
# Changes may cause incorrect behavior and will be lost if the code is
# regenerated.
# --------------------------------------------------------------------------

from msrest.serialization import Model


class Model(Model):
    """Instance of an Azure Machine Learning Model.

    Variables are only populated by the server, and will be ignored when
    sending a request.

    :ivar id: The Model Id
    :vartype id: str
    :param name: The Model name
    :type name: str
    :ivar version: The Model version assigned by Model Management Service
    :vartype version: int
    :param tags: Model tag list
    :type tags: list[str]
    :param url: The URL of the Model. Usually we put a SAS URL here.
    :type url: str
    :param mime_type: The MIME type of Model content. For more details about
     MIME type, please open
     https://www.iana.org/assignments/media-types/media-types.xhtml
    :type mime_type: str
    :param description: The Model description text
    :type description: str
    :ivar created_at: The Model creation time as a DateTimeOffset
    :vartype created_at: datetime
    :ivar created_time: The Model creation time (UTC)
    :vartype created_time: datetime
    :param unpack: Indicates whether we need to unpack the Model during docker
     Image creation.
    :type unpack: bool
    """

    _validation = {
        'id': {'readonly': True},
        'name': {'required': True},
        'version': {'readonly': True},
        'url': {'required': True},
        'mime_type': {'required': True},
        'created_at': {'readonly': True},
        'created_time': {'readonly': True},
    }

    _attribute_map = {
        'id': {'key': 'id', 'type': 'str'},
        'name': {'key': 'name', 'type': 'str'},
        'version': {'key': 'version', 'type': 'int'},
        'tags': {'key': 'tags', 'type': '[str]'},
        'url': {'key': 'url', 'type': 'str'},
        'mime_type': {'key': 'mimeType', 'type': 'str'},
        'description': {'key': 'description', 'type': 'str'},
        'created_at': {'key': 'createdAt', 'type': 'iso-8601'},
        'created_time': {'key': 'createdTime', 'type': 'iso-8601'},
        'unpack': {'key': 'unpack', 'type': 'bool'},
    }

    def __init__(self, name, url, mime_type, tags=None, description=None, unpack=None):
        super(Model, self).__init__()
        self.id = None
        self.name = name
        self.version = None
        self.tags = tags
        self.url = url
        self.mime_type = mime_type
        self.description = description
        self.created_at = None
        self.created_time = None
        self.unpack = unpack
